
* PROGRAM: CONVERT_DST.SAS;
* CONVERTS APPROPRIATE CHARACTER VARIABLES TO NUMERIC LENGTH 8;
options mprint source2;

%macro c_to_n(varlist=,informat=8.);

   %local i word delm;
   %let delm = %str( );
   %let note = %str(NOTES);
   %let yn = %str(_YN);
   %let cats = %str(_CATS);
   %let bens = %str(_BENS);
   %let type = %str(_TYPE_);
   %let per = %str(_PER_);
   %let amo = %str(_AMO_);
   %let pov = %str(_POV);
   %let per_ = %str(_PER);
   %let typ_ = %str(_TYPE);
   %let ad = %str(LIM_AD);
   %let auth = %str(_AUTH);
   %let catex = %str(CATEX);
   %let cat_ex = %str(CAT_EX);
   %let charge = %str(_CHARGE);
   %let apply = %str(_APPLY);
   %let endshare = %str(_SHARE);
   %let share = %str(_SHARE_);
   %let oopt = %str(_OOPT);
   %let id = %str(_ID);
   %let struct = %str(_STRUCT);
   %let service = %str(_SERVICE);
   %let upload = %str(UPLOAD_FILENAME);
   %let name = %str(_NAME);
   %let phone = %str(_PHONE);
   %let flag = %str(_FLAG);
   %let status = %str(STATUS);
   %let p_pbp_a = %str(P_PBP_A);
   %let pbp_a = %str(PBP_A);
   %let spc_var = %str(MRX_ALT_NO_DED_TIER);
   %let ehc_var = %str(_EHC);
   %let label_var = %str(_LABEL);
   %let mrxtpstdesc = %str(MRX_TIER_POST_FORM_MODEL_DESC);
   %let mrxtfrmdesc = %str(MRX_TIER_FORM_MODEL_DESC);
   %let mrxfrmdesc = %str(MRX_FORM_MODEL_DESC);
   %let rpbendesc = %str(PBP_B14C_RP_BENDESC_OTHER);
   %let hwaiver = %str(PBP_B13H_WAIVER);
   %let hpayamt = %str(PBP_B13H_PAYAMT);
   %let vbd = %str(_VBD_);
   %let mrxtype = %str(MRX_FORM_MODEL_TYPE);
   %let mrxpostlab = %str(MRX_TIER_POST_LABEL_LIST);
   %let partddemo = %str(PART_D_MODEL_DEMO);
   %let goaldesc = %str(MRX_D_ADHER_GOAL_DESC);
   %let mrxraidesc1=%str(MRX_RAI_FRQ_RI_DESC_1RX);
   %let mrxraidesc2=%str(MRX_RAI_FRQ_RI_DESC_2RX);
   %let mrxraidesc3=%str(MRX_RAI_FRQ_RI_DESC_3RX);
   %let b19cothman=%str(PBP_B19C_OTH_MAN_SUPP_BEN);
   %let b19whp=%str(PBP_B19_WHP_ELIGIBIL_CRIT);
   %let b19desc1=%str(PBP_B19_C_RI_FREQ_DESC_1);
   %let mrxdeligf=%str(MRX_D_ELIG_FREQ_OTHER);
   %let mrxdeligcrit=%str(MRX_D_ELIGCRIT_OTHER);
   %let mrxssmt1=%str(MRX_SSM_CUI_TIERS_1_CHK);
   %let mrxssmt2=%str(MRX_SSM_CUI_TIERS_2_CHK);
   %let mrxssmt3=%str(MRX_SSM_CUI_TIERS_3_CHK);
   %let mrxssmt4=%str(MRX_SSM_CUI_TIERS_4_CHK);
   %let mrxssmt5=%str(MRX_SSM_CUI_TIERS_5_CHK);
   %let ptdenhcvrgdem=%str(PART_D_ENHNCD_CVRG_DEMO);
   %let pbp14cscenote=%str(PBP_B14C_SCE_NOTE);
   %let pbpdcombomode=%str(PBP_D_COMBO_MODE);
   %let pbpasnpcondoth=%str(PBP_A_SNP_COND_OTH);
   %let pbpdricsmod=%str(PBP_D_RICS_MOD);
   %let b16bmxplndesc=%str(PBP_B16B_MAXPLAN_PER_DESC);
   %let b16bmxenrdesc=%str(PBP_B16B_MAXENR_PER_DESC);
   %let b16amxplndesc=%str(PBP_B16A_MAXPLAN_PER_DESC);
   %let b16amxenrdesc=%str(PBP_B16A_MAXENR_PER_DESC);
   %let ssmsmocs1chk=%str(MRX_SSM_SMOCS_1_CHK);
   %let ssmsmocs2chk=%str(MRX_SSM_SMOCS_2_CHK);
   %let ssmsmocs3chk=%str(MRX_SSM_SMOCS_3_CHK);
   %let ssmsmocs4chk=%str(MRX_SSM_SMOCS_4_CHK);
   %let ssmsmocs5chk=%str(MRX_SSM_SMOCS_5_CHK);
   %let ssmprcs1chk=%str(MRX_SSM_PRCS_1_CHK);
   %let ssmprcs2chk=%str(MRX_SSM_PRCS_2_CHK);
   %let ssmprcs3chk=%str(MRX_SSM_PRCS_3_CHK);
   %let ssmprcs4chk=%str(MRX_SSM_PRCS_4_CHK);
   %let ssmprcs5chk=%str(MRX_SSM_PRCS_5_CHK);
   %let ssmltcp1chk=%str(MRX_SSM_LTCP_1_CHK);
   %let ssmltcp2chk=%str(MRX_SSM_LTCP_2_CHK);
   %let ssmltcp3chk=%str(MRX_SSM_LTCP_3_CHK);
   %let ssmltcp4chk=%str(MRX_SSM_LTCP_4_CHK);
   %let ssmltcp5chk=%str(MRX_SSM_LTCP_5_CHK);
   %let ssmsrcs1chk=%str(MRX_SSM_SRCS_1_CHK);
   %let ssmsrcs2chk=%str(MRX_SSM_SRCS_2_CHK);
   %let ssmsrcs3chk=%str(MRX_SSM_SRCS_3_CHK);
   %let ssmsrcs4chk=%str(MRX_SSM_SRCS_4_CHK);
   %let ssmsrcs5chk=%str(MRX_SSM_SRCS_5_CHK);
   %let ssmpmocs1chk=%str(MRX_SSM_PMOCS_1_CHK);
   %let ssmpmocs2chk=%str(MRX_SSM_PMOCS_2_CHK);
   %let ssmpmocs3chk=%str(MRX_SSM_PMOCS_3_CHK);
   %let ssmpmocs4chk=%str(MRX_SSM_PMOCS_4_CHK);
   %let ssmpmocs5chk=%str(MRX_SSM_PMOCS_5_CHK);
   %let ssmoonp1chk=%str(MRX_SSM_OONP_1_CHK);
   %let ssmoonp2chk=%str(MRX_SSM_OONP_2_CHK);
   %let ssmoonp3chk=%str(MRX_SSM_OONP_3_CHK);
   %let ssmoonp4chk=%str(MRX_SSM_OONP_4_CHK);
   %let ssmoonp5chk=%str(MRX_SSM_OONP_5_CHK); 
   
   %let b13haddser=%str(PBP_B13H_ADDL_SERVICES);    
   %let b13hlimser=%str(PBP_B13H_LIMIT_SERVICES);    
   %let b13hmaxplnser=%str(PBP_B13H_MAXPLAN_SERVICES);    
   %let b13haddsrvcoin=%str(PBP_B13H_ADD_SRVCS_COINS_ITEMS);    
   %let b13haddsrvcopay=%str(PBP_B13H_ADD_SRVCS_COPAY_ITEMS);    
   %let b13hauthserv=%str(PBP_B13H_AUTH_SERVICES); 
   %let b13hrefserv=%str(PBP_B13H_REF_SERVICES); 
   %let b13cmealtype=%str(PBP_B13C_MEAL_TYPE_CHK); 
   %let b13ibendesc=%str(PBP_B13I_BENDESC); 
   %let b13itbendescmtpal=%str(PBP_B13I_T_BENDESC_MT_PAL); 
   %let b13itbendescmtal=%str(PBP_B13I_T_BENDESC_MT_AL); 
   %let b13ibendesoth=%str(PBP_B13I_BENDESC_OTH); 
   
   %let ssmelgcrit1chk=%str(MRX_SSM_ELIGCRIT_1_CHK);
   %let ssmelgcrit2chk=%str(MRX_SSM_ELIGCRIT_2_CHK);
   %let ssmelgcrit1oth=%str(MRX_SSM_ELIGCRIT_1_OTHER);
   %let ssmelgcrit2oth=%str(MRX_SSM_ELIGCRIT_2_OTHER);
   %let ssmrityp1chk=%str(MRX_SSM_RI_TYPE_1_CHK);
   %let ssmrityp2chk=%str(MRX_SSM_RI_TYPE_2_CHK);
   %let ssmadgoaldes1=%str(MRX_SSM_ADHER_GOAL_1_DESC);
   %let ssmadgoaldes2=%str(MRX_SSM_ADHER_GOAL_2_DESC);
   %let ssmelgfrq1oth=%str(MRX_SSM_ELIG_FREQ_1_OTHER);
   %let ssmelgfrq2oth=%str(MRX_SSM_ELIG_FREQ_2_OTHER);
   %let ssmcuitier1chk=%str(MRX_SSM_CUI_TIERS_1_CHK);
   %let ssmcuitier2chk=%str(MRX_SSM_CUI_TIERS_2_CHK);
   %let mrxtierincl=%str(MRX_TIER_INCLUDES);
   %let mrxfirstfill=%str(MRX_FIRST_FILL);


   %let i    = 1;
   %let word = %scan(&varlist,&i,&delm);
   %let indword = %index(&word,&note) + %index(&word,&yn) + %index(&word,&cats) + %index(&word,&bens) +
        %index(&word,&type) + %index(&word,&per) + %index(&word,&amo) + %index(&word,&pov) +
        %index(&word,&per_) + %index(&word,&typ_) + %index(&word,&ad) + %index(&word,&auth) +
        %index(&word,&catex) + %index(&word,&cat_ex) + %index(&word,&charge) + %index(&word,&oopt)  +
        %index(&word,&apply) + %index(&word,&share) - %index(&word,&endshare) + %index(&word,&id) +
        %index(&word,&struct) + %index(&word,&service) + %index(&word,&name) + %index(&word,&phone) +
        %index(&word,&flag)+ %index(&word,&status) + %index(&word,&p_pbp_a) + %index(&word,&pbp_a) +
        %index(&word,&spc_var) + %index(&word,&ehc_var) + %index(&word,&label_var) + %index(&word,&mrxtpstdesc) +
        %index(&word,&mrxtfrmdesc) + %index(&word,&mrxfrmdesc) + %index(&word,&rpbendesc) + 
        %index(&word,&hwaiver) + %index(&word,&hpayamt) + %index(&word,&vbd) + %index(&word,&mrxtype) + 
        %index(&word,&mrxpostlab) + %index(&word,&partddemo) + %index(&word,&goaldesc) +
        %index(&word,&mrxraidesc1) + %index(&word,&mrxraidesc2) + %index(&word,&mrxraidesc3) +
        %index(&word,&b19cothman) + %index(&word,&b19whp) + %index(&word,&b19desc1) +
        %index(&word,&mrxdeligf) + %index(&word,&mrxdeligcrit) + %index(&word,&mrxssmt1) +
        %index(&word,&mrxssmt2) + %index(&word,&mrxssmt3) + %index(&word,&mrxssmt4) + 
        %index(&word,&mrxssmt5) + %index(&word,&ptdenhcvrgdem) + %index(&word,&pbp14cscenote) +
        %index(&word,&pbpdcombomode) + %index(&word,&pbpasnpcondoth) + %index(&word,&pbpdricsmod) +
        %index(&word,&b16bmxplndesc) + %index(&word,&b16bmxenrdesc) + %index(&word,&b16amxplndesc) +
        %index(&word,&b16amxenrdesc) + %index(&word,&ssmsmocs1chk) + %index(&word,&ssmsmocs2chk) + 
        %index(&word,&ssmsmocs3chk) + %index(&word,&ssmsmocs4chk) + %index(&word,&ssmsmocs5chk) +         
        %index(&word,&ssmprcs1chk) + %index(&word,&ssmprcs2chk) + %index(&word,&ssmprcs3chk) + 
        %index(&word,&ssmprcs4chk) + %index(&word,&ssmprcs5chk) + %index(&word,&ssmltcp1chk) + 
        %index(&word,&ssmltcp2chk) + %index(&word,&ssmltcp3chk) + %index(&word,&ssmltcp4chk) + 
        %index(&word,&ssmltcp5chk) + %index(&word,&ssmsrcs1chk) + %index(&word,&ssmsrcs2chk) + 
        %index(&word,&ssmsrcs3chk) + %index(&word,&ssmsrcs4chk) + %index(&word,&ssmsrcs5chk) + 
        %index(&word,&ssmpmocs1chk) + %index(&word,&ssmpmocs2chk) + %index(&word,&ssmpmocs3chk) + 
        %index(&word,&ssmpmocs4chk) + %index(&word,&ssmpmocs5chk) + %index(&word,&ssmoonp1chk) + 
        %index(&word,&ssmoonp2chk) + %index(&word,&ssmoonp3chk) + %index(&word,&ssmoonp4chk) + 
        %index(&word,&ssmoonp5chk) + %index(&word,&b13haddser) + %index(&word,&b13hlimser) +               
        %index(&word,&b13hmaxplnser) + %index(&word,&b13haddsrvcoin) + %index(&word,&b13haddsrvcopay) +       
        %index(&word,&b13hauthserv) + %index(&word,&b13hrefserv) + %index(&word,&b13cmealtype) +               
        %index(&word,&b13ibendesc) + %index(&word,&b13itbendescmtpal) + %index(&word,&b13itbendescmtal) +               
        %index(&word,&b13ibendesoth) + %index(&word,&ssmelgcrit1chk) + %index(&word,&ssmelgcrit2chk) +  
        %index(&word,&ssmelgcrit1oth) + %index(&word,&ssmelgcrit2oth) + %index(&word,&ssmrityp1chk) + 
        %index(&word,&ssmrityp2chk) + %index(&word,&ssmadgoaldes1) + %index(&word,&ssmadgoaldes2) +
        %index(&word,&ssmelgfrq1oth) + %index(&word,&ssmelgfrq2oth) + %index(&word,&ssmcuitier1chk) +
        %index(&word,&ssmcuitier2chk) + %index(&word,&mrxtierincl) + %index(&word,&mrxfirstfill);
        
   %do %while("&word"^="");

      %if "&word" ^= "QID" and "&word" ^= "QID_OLD" and "&word" ^= "hplan" and "&word" ^= "UPLOAD_FILENAME" 
      and "%eval(&indword)" = "0" and "&word" ^= "HPLAN" and "&word" ^= "TYPE" %then %do;
         length _&i &informat;
         _&i = input(&word,&informat);
      drop &word;
      rename _&i = &word;
      %end;
      %else %do;
        %if "&word" = "PBP_B16B_BENDESC_NUM_PERI" or "&word" = "PBP_B16B_COPAY_AMT_PERI_MIN" or
          "&word" = "PBP_B16B_COINS_PCT_PERI_MIN" %then %do;
          length _PBP_B16B_BENDESC_NUM_PERI _PBP_B16B_COPAY_AMT_PERI_MIN _PBP_B16B_COINS_PCT_PERI_MIN &informat;
          _PBP_B16B_BENDESC_NUM_PERI = input(PBP_B16B_BENDESC_NUM_PERI,&informat);          
          _PBP_B16B_COPAY_AMT_PERI_MIN = input(PBP_B16B_COPAY_AMT_PERI_MIN,&informat);
          _PBP_B16B_COINS_PCT_PERI_MIN = input(PBP_B16B_COINS_PCT_PERI_MIN,&informat);
          drop PBP_B16B_BENDESC_NUM_PERI PBP_B16B_COPAY_AMT_PERI_MIN PBP_B16B_COINS_PCT_PERI_MIN;
          rename _PBP_B16B_BENDESC_NUM_PERI = PBP_B16B_BENDESC_NUM_PERI 
                 _PBP_B16B_COPAY_AMT_PERI_MIN = PBP_B16B_COPAY_AMT_PERI_MIN
                 _PBP_B16B_COINS_PCT_PERI_MIN = PBP_B16B_COINS_PCT_PERI_MIN;
        %end; 
      %end;

      %let i = %eval(&i + 1);
      %let word = %scan(&varlist,&i,&delm);
      %let indword = %index(&word,&note) + %index(&word,&yn) + %index(&word,&cats) + %index(&word,&bens) +
        %index(&word,&type) + %index(&word,&per) + %index(&word,&amo) + %index(&word,&pov) +
        %index(&word,&per_) + %index(&word,&typ_) + %index(&word,&ad) + %index(&word,&auth) +
        %index(&word,&catex) + %index(&word,&cat_ex) + %index(&word,&charge) + %index(&word,&oopt) +
        %index(&word,&apply)  + %index(&word,&share) - %index(&word,&endshare)+ %index(&word,&id) +
        %index(&word,&struct) + %index(&word,&service) + %index(&word,&name) + %index(&word,&phone)
        + %index(&word,&flag)+ %index(&word,&status) + %index(&word,&p_pbp_a) + %index(&word,&pbp_a)
        + %index(&word,&spc_var) + %index(&word,&ehc_var) + %index(&word,&label_var) + %index(&word,&mrxtpstdesc) +
        %index(&word,&mrxtfrmdesc) + %index(&word,&mrxfrmdesc) + %index(&word,&rpbendesc) + 
        %index(&word,&hwaiver) + %index(&word,&hpayamt) + %index(&word,&vbd) + %index(&word,&mrxtype) + 
        %index(&word,&mrxpostlab) + %index(&word,&partddemo) + %index(&word,&goaldesc) + 
        %index(&word,&mrxraidesc1) + %index(&word,&mrxraidesc2) + %index(&word,&mrxraidesc3) + 
        %index(&word,&b19cothman) + %index(&word,&b19whp) + %index(&word,&b19desc1) +
        %index(&word,&mrxdeligf) + %index(&word,&mrxdeligcrit) + %index(&word,&mrxssmt1) +
        %index(&word,&mrxssmt2) + %index(&word,&mrxssmt3) + %index(&word,&mrxssmt4) + 
        %index(&word,&mrxssmt5) + %index(&word,&ptdenhcvrgdem) + %index(&word,&pbp14cscenote) +
        %index(&word,&pbpdcombomode) + %index(&word,&pbpasnpcondoth) + %index(&word,&pbpdricsmod) +
        %index(&word,&b16bmxplndesc) + %index(&word,&b16bmxenrdesc) + %index(&word,&b16amxplndesc) +
        %index(&word,&b16amxenrdesc) + %index(&word,&ssmsmocs1chk) + %index(&word,&ssmsmocs2chk) +
        %index(&word,&ssmsmocs3chk) + %index(&word,&ssmsmocs4chk) + %index(&word,&ssmsmocs5chk) +
        %index(&word,&ssmprcs1chk) + %index(&word,&ssmprcs2chk) + %index(&word,&ssmprcs3chk) +
        %index(&word,&ssmprcs4chk) + %index(&word,&ssmprcs5chk) + %index(&word,&ssmltcp1chk) +
        %index(&word,&ssmltcp2chk) + %index(&word,&ssmltcp3chk) + %index(&word,&ssmltcp4chk) +
        %index(&word,&ssmltcp5chk) + %index(&word,&ssmsrcs1chk) + %index(&word,&ssmsrcs2chk) +
        %index(&word,&ssmsrcs3chk) + %index(&word,&ssmsrcs4chk) + %index(&word,&ssmsrcs5chk) +
        %index(&word,&ssmpmocs1chk) + %index(&word,&ssmpmocs2chk) + %index(&word,&ssmpmocs3chk) +
        %index(&word,&ssmpmocs4chk) + %index(&word,&ssmpmocs5chk) + %index(&word,&ssmoonp1chk) +
        %index(&word,&ssmoonp2chk) + %index(&word,&ssmoonp3chk) + %index(&word,&ssmoonp4chk) +
        %index(&word,&ssmoonp5chk) + %index(&word,&b13haddser) + %index(&word,&b13hlimser) +
        %index(&word,&b13hmaxplnser) + %index(&word,&b13haddsrvcoin) + %index(&word,&b13haddsrvcopay) +
        %index(&word,&b13hauthserv) + %index(&word,&b13hrefserv) + %index(&word,&b13cmealtype) +
        %index(&word,&b13ibendesc) + %index(&word,&b13itbendescmtpal) + %index(&word,&b13itbendescmtal) +        
        %index(&word,&b13ibendesoth) + %index(&word,&ssmelgcrit1chk) + %index(&word,&ssmelgcrit2chk) +  
        %index(&word,&ssmelgcrit1oth) + %index(&word,&ssmelgcrit2oth) + %index(&word,&ssmrityp1chk) +  
        %index(&word,&ssmrityp2chk) + %index(&word,&ssmadgoaldes1) + %index(&word,&ssmadgoaldes2) +
        %index(&word,&ssmelgfrq1oth) + %index(&word,&ssmelgfrq2oth) + %index(&word,&ssmcuitier1chk) +
        %index(&word,&ssmcuitier2chk) + %index(&word,&mrxtierincl) + %index(&word,&mrxfirstfill);
        
      %end;        
 
   %mend c_to_n;
run;

%macro getvars;
drop nm x varlist;
*if LAST = 1 then do;
array ch(*) _character_;
length nm $32 varlist $32767;
varlist='';
call symput('vars',varlist);
do x=1 to dim(ch);
   nm = vname(ch(x));
   if x = 1 then do;
      varlist = upcase(trim(nm));
   end;
   else do;
      varlist = trim(varlist)||' '||upcase(trim(nm));
   end;
end;
call symput('vars',varlist);
*end;
%mend;

%MACRO PBPIMPCONV(TABLE);

PROC SORT DATA= PBP.&TABLE OUT=NEW&TABLE;
WHERE PUT(SUBSTR(QID,1,11),$HPLANF.) = 'YES';
BY QID;
RUN;

DATA _NULL_;
CALL SYMPUT('OBSNUM',TRIM(LEFT(PUT(NUMOBS,4.))));
STOP;
SET NEW&TABLE NOBS=NUMOBS;
STOP;
RUN;

DATA &TABLE;
SET NEW&TABLE (RENAME=QID=QID_OLD);
LENGTH QID $11;
QID=SUBSTR(QID_OLD,1,11);
DROP QID_OLD;
%IF &OBSNUM > 0 %THEN %DO;
%GETVARS;
%END;
RUN;

DATA &TABLE;
SET &TABLE;
%IF &OBSNUM > 0 %THEN %DO;
%c_to_n(varlist = &vars);
%END;
RUN;

%MEND;
RUN;
